#
# name  : routines.pl
# author: jolly - who else ?
#
$donothing=1;   # needed for including
#####################################################################################
# Below are only subroutines
# needed for the distributed system change these only if you know what you're doing !
#####################################################################################



# ########
# send message ( address, origin, messageid, order, messagebody )
# ########

sub umessage
{
    local($addr,$origin,$origid,$order,$message)=@_;
    local($olen,$hlen,$mlen,$header,$mesg);
    
    return undef if $addr eq $myhostaddr;
    return undef if !$hardrouted{$addr};

    $olen=length($order);
    $header=pack("i a4 N a$olen",$myboottime,$origin,$origid,$order);
    $hlen=length($header);
    $mlen=length($message);
    $mesg=pack("n a$hlen a$mlen",$hlen,$header,$message);
    send(SENDSOCKET,$mesg,undef,$hardrouted{$addr}) || die "send:$!\n";

    $_=$order;
    if( (!/p.ng/) || ($debug>2) )
    {
    printf STDERR "SENT%4d %20s (%10s/%4d) TO:%s\n",$mlen,$order,$hostname{$origin},$origid,$hostname{$addr} if $debug>1;
    }
}

 
# ########
# recvmessage returns ( $from,$fromid,$origin,$origid,$order,$message ) 
# ########

sub recvmessage
{
    local($fam,$port,$from);
    local($glen,$hlen,$mesg,$mlen,$mom,$header);
    local($fromid,$origin,$origid,$order,$message);

    $mom=recv(RECVSOCKET,$mesg,10000,0);
    ($fam,$port,$from)=unpack('S n a4 x8',$mom);
 
    $glen=length($mesg);
    $hlen=unpack("n",$mesg);
    $mlen=$glen-$hlen-2;
    ($mom,$header,$message)=unpack("n a$hlen a$mlen",$mesg);
    $olen=$hlen-8;
    ($fromid,$origin,$origid,$order)=unpack("i a4 N a$olen",$header);
 
    $_=$order;
    if( (!/p.ng/) || ($debug>2) )
    {
    printf STDERR "RECV%4d %20s (%10s/%4d) FROM:%s/%d\n", $mlen,$order,$hostname{$origin},$origid,$hostname{$from},$fromid if $debug>1;
    } 
    return ($from,$fromid,$origin,$origid,$order,$message);
}


# ########
# send reliable message
# ########

sub rmessage
{
    local($addr,$origin,$messageid,$order,$message)=@_;
    $raddr{$messageid}=$addr;
    $rorigin{$messageid}=$origin;
    $rorder{$messageid}=$order;
    $rmessage{$messageid}=$message;
    &umessage($addr,$origin,$messageid,$order,$message);
}


sub sendCommand
{
    local($addr,$cmd,$message)=@_;
    &rmessage($addr,$myhostaddr,++$mymessageid,"command:$cmd",$message);
    return undef;   
}

# ########
# decode a string into an array of hosts
# ########

sub decodehosts
{
    local($message)=@_;
    local(@hosts,$count,$fasel,$mom);

    return undef if !$message;
    $count=unpack("n",$message);
    return undef if !($count);
    $fasel=0;
    do
    {
        $mom=4*$fasel;
        push(@hosts,unpack("x2 x$mom a4",$message));
    }
    while((++$fasel)<$count);
    return @hosts;
}


# ########
# encode an array of hosts into a string
# ########

sub encodehosts
{
    local(@hosts)=@_;
    local($mom,$mesg,$message);
    undef $mesg;

    return undef if !@hosts;
    foreach $mom (@hosts)
    {
        $mesg.=pack("a4",$mom) if $mom;
    }
    return undef if !$mesg;
    $message=pack("n",length($mesg)/4);
    $message.=$mesg;
    return $message;
}




sub isreceived
{
    local($host,$number)=@_;    

    $mom=$received{$from};
    while($mom)
    {
        ($low,$high)=unpack("N N",$mom);

        if( ($low le $number) && ($high ge $number) )
        {
            return 1;
        }
        $mom=substr($mom,8);
    }
    return 0;
}

sub addreceived
{
    local($host,$number)=@_;
    local($all,$low,$high);
    
    undef $all;
    return if &isreceived($host,$number);

    $mom=$received{$from};
    while($mom)
    {
        ($low,$high)=unpack("N N",$mom);
        if( ($low-1) eq $number)
        {
            $all.=pack("N N",$number,$high);
            $all.=substr($mom,8);
            $received{$host}=$all;
            return undef;
        }
        if( ($high+1) eq $number)
        {
            $all.=pack("N N",$low,$number);
            $all.=substr($mom,8);
            $received{$host}=$all;
            return undef;
        }
        $all=substr($mom,0,8);
        $mom=substr($mom,8);
    }
    $all.=pack("N N",$number,$number);
    $received{$host}=$all;
    return undef;
}


sub printrouting
{
    local($mom,$fasel);
    print "\nROUTING TABLE\n";
    print "=============\n";
    foreach $mom (keys(%router))
    {
        printf STDERR "\t\$router{%10s}  = %10s\t%6.2f %3d\n"
        ,$hostname{$mom},$hostname{$router{$mom}},$rely{$mom},$hops{$mom} if $mom ne $myhostaddr;
    }
    foreach $mom (keys(%broadcast))
    {
        print STDERR "\tBroadcast from $hostname{$mom} routed to :";
        foreach $fasel ( &decodehosts($broadcast{$mom}) )
        {
        print STDERR "$hostname{$fasel},";
        }
    print STDERR ".\n";
    }
    print STDERR "\n";
}
 
 



# ########
# allroutes($from) returns all routings made for server $from
# ########

sub allroutes
{
    local($from)=@_;
    local($mom,$mesg);

    undef $mesg;
    
    foreach $mom (keys(%broadcast))
    {
        @hosts=&decodehosts($broadcast{$mom});
        if( grep(/$from/,@hosts) )
        {
            $mesg.=pack("a4 s f",$mom,$hops{$mom},$speed{$mom});
        }
    }
    return $mesg;
}


# ########
# broadcastintegrety  
# ########

sub broadcastintegrety
{
    undef %delroute;

    foreach $mom (keys(%broadcast))
    {
        if( !$router{$mom} )
        {
            print STDERR "Deleting broadcast for $hostname{$mom}\n" if $debug;
            @hosts=&decodehosts($broadcast{$mom});
            foreach $rem (@hosts)
            {
                $delroute{$rem}.=$mom;
            }
            $broadcast{$mom}=undef;
        }
        else
        {
            undef %fasel;

            foreach $rem (&decodehosts($broadcast{$mom}))
            {
                push(@fasel,$rem) if $rely{$rem}>=$reliable; 
            }
            @fasel=grep(! /$mom/,@fasel);
            @fasel=grep(! /$router{$mom}/,@fasel);
            $broadcast{$mom}=&encodehosts(@fasel);
        }
    }
    foreach $mom (keys(%delroute))
    {
        $len=length($delroute{$mom});
        $message=pack("n a$len",$len/4,$delroute{$mom});
        &rmessage($mom,$myhostaddr,++$myrmessageid,"delete routes",$message);
    }

    return undef;
}




sub removehost
{
    local($host)=@_;

    $router{$host}=undef;
    $hops{$host}=undef;

    print STDERR "Removing host called with $hostname{$host}\n" if $debug;
    foreach $mom ( keys(%router) )
    {
            $router{$mom}=undef if $router{$mom} eq $host;
    }
    &broadcastintegrety;
    
    return undef;
}


sub addroutes
{
    local($from,$message)=@_;
    local($addr,$hops,$speed);
    undef %oldroute;
    undef $newroutes;

    while($message) 
    {
        ($addr,$hops,$speed)=unpack("a4 s f",$message);
        next if $addr eq $myhostaddr;
        $speed+=$speed{from};
        $hops++;
        if( $router{$addr} && ( $router{$addr} ne $from ) && ($hops{$addr}<$hops) )
        {
            $oldroute{$from}.=$addr;
        }
        else
        {
            if(!$hostname{$addr})
            {
                ($name)=gethostbyaddr($addr,&PF_INET);
                $hostname{$addr}=$name;
            }
            $oldroute{$router{$addr}}.=$addr if $router{$addr} ne $from ;
            $router{$addr}=$from;
            $hops{$addr}=$hops;
            $speed{$addr}=$speed;

            $newroutes.=pack("a4 s f",$addr,$hops,$speed);
        }
        $message=substr($message,10);
    }

    
    foreach $mom (keys(%oldroute))
    {
        $len=length($oldroute{$mom});
        $message=pack("n a$len",$len/4,$oldroute{$mom});
        &rmessage($mom,$myhostaddr,++$myrmessageid,"delete broadcast",$message);
    }

    foreach $mom (keys(%hardrouted))
    {
        if( ($from ne $mom) && ($rely{$mom}>=$reliable) )
        {
            &umessage($mom,$myhostaddr,++$mymessageid,"i know",$newroutes);
        }
    }
    return undef;
}




