#!/usr/local/bin/perl
#
#	title	:	dispatcher.pl
#	author	:	jolly
#	version	:	1.00
#	date	:	Sat Jun 18 15:01:51 MST 1994
#
#	purpos	:	easy telenet session dispatcher for the 
#				simpleHandler ( hander.pl)
#
#
# this file won't be included by anyone else ... it's a telnet server !
#

require 'sys/socket.ph';
require 'sys/ioctl.ph';
require 'sys/file.ph';
chop($startdir=`echo ~/con`);
chop($hostname=`/bin/hostname`);
$port=10000;
$SIG{'CHLD'}='IGNORE';
$SIG{'INT'}='interrupt';

($name,$aliases,$proto) = getprotobyname('tcp');
socket(SOCKET,&AF_INET,&SOCK_STREAM,(getprotobyname('tcp'))[2]);
bind(SOCKET,pack('S n a4 x8',&AF_INET,$port,"\0\0\0\0")) || die "can't bind\n"; 
listen(SOCKET,5) || die "can't listen to socket\n";


&reloadMessagetable || die "Having problems on the $startdir/$hostname directory\n";
&reloadPasswd || die "having problems reading the passwd file\n";

close(STDIN);
close(STDOUT);
close(STDERR);
while(1)
{
	$addr=accept(CON,SOCKET);
	if(fork()==0)
	{
		close(SOCKET);
		select(CON);$|=1;
		if( ! &reloadPasswd)
		{
			print "Having problems on login-mechanism.\n";
			close(CON);
			exit;
		}
		$USER=undef;
		$trylogin=2;
		while(!$USER && (--$trylogin>=0) )
		{
			do
			{
				print 'login :';
				&input;
				$test=$_;
			}
			while(!$test);
			print 'Password:';
			&input;
			if( ($login{$test}==1) && (crypt($_,$passwd{$login}) eq $passwd{$login}) )
			{
				$USER=$test;	
			}
		}
		if(!$USER)
		{
			close(CON);
			exit;
		}
		
		print "Welcome to $hostname\n\n\n"; 
		print "Supported Commands : ls more new remove\n";
		print "                     date\n";
		print "                     quit,exit\n\n";
		print 'COMMAND>';
		while(1)
		{
			&input;
			tr/A-Z/a-z/;
			&handlecommand;	
			print 'COMMAND>';
		}
		close(CON);
		exit;
	}
	close(CON);
}

sub interrupt
{
	print STDERR "Interrupted ... shuting down.\n";
	close(SOCKET);
	exit;
}

sub handlecommand
{
	if(/^q$/ || /^exit$/ || /^quit$/ || /^logout$/ || /^logoff$/)
	{
		print "Good bye.\n";
		close(CON);
		exit;
	}
	if(/^date$/ || /^time$/)
	{
		print `date`;
		return undef;
	}

	if(/^ls$/ || /^dir$/)
	{
		if(!&reloadMessagetable)
		{
			print "Sorry having problems to read directory\n";
			close(CON);
			exit;
		}
		
		foreach (sort(keys(%filename)))
		{
			print "$_\t$subject{$_}\t$author{$_}\n";
		}
		return undef;
	}


	if(/^more$/ || /^show$/ )
	{
		print "Usage: $_ <filenumber>\n";
		return undef; 
	}

	if(/^show\s+(.*)$/ || /^more\s+(.*)$/ || /^mroe\s+(.*)$/ || /^mreo\s+(.*)$/)
	{
		if(!open(MOMFILE,"$startdir/$hostname/messages/$filename{$1}"))
		{
			print "$1: No such file.\n";
		}
		while(<MOMFILE>)
		{
			print;
		}
		close(MOMFILE);
		return undef;
	}
	
	if(/^rm\s+(.*)$/ || /^remove\s+(.*)$/ )
	{
		if( -f "$startdir/$hostname/remove" )
		{
			sleep 2;
			if( -f "$startdir/$hostname/remove" )
			{
				print "Server does not run !\n";
				print "can't remove message\n";
				return undef;
			}
		}
		
		if( $group{$USER} ne 'OPERATOR' )
		{
			print "You don't have the permission\n";
			return undef;
		}
		if(! -f "$startdir/$hostname/messages/$filename{$1}")
		{
			print "Message does not exist\n";
			return undef;
		}
			
		if(! open(MOMFILE,">> $startdir/$hostname/remove.lock") )
		{
			print "Can't remove message\n";
			return undef;
		}
		if( (!&lock(MOMFILE)) || (!open(FILE,"> $startdir/$hostname/remove.mom")) )
		{
			&unlock(MOMFILE);
			close(MOMFILE);
			print "Can't remove message\n";
			return undef;
		}
		print FILE "$filename{$1}\n"; 
		close(FILE);
		system "mv $startdir/$hostname/remove.mom $startdir/$hostname/remove";
		&unlock(MOMFILE);
		print "Message will be removed by the server.\n";
		close(MOMFILE);
		return undef;
	}


	if(/^new$/ || /^create$/ )
	{
		if( -f "$startdir/$hostname/message" )
		{
			sleep 2;
			if( -f "$startdir/$hostname/message" )
			{
				print "Server does not run !\n";
				print "can't store message\n";
				return undef;
			}
		}
		
		print "Subject:";	
		return undef if !&input;
		$subject=$_;
		print "To end message enter '.'\n";
		do
		{
			&input;
			$message.="$_\n" if !/^.$/;
		}
		while(! /^\.$/ );

		if(! open(MOMFILE,">> $startdir/$hostname/message.lock") )
		{
			print "Can't store message\n";
			return undef;
		}
		if( (!&lock(MOMFILE)) || (!open(FILE,"> $startdir/$hostname/message.mom")) )
		{
			&unlock(MOMFILE);
			close(MOMFILE);
			print "Can't store message\n";
			return undef;
		}
		print FILE "Date   : ";print FILE `date`;
		print FILE "Author : $realname{$USER} ($email{$USER})\n";
		print FILE "Subject: $subject\n";
		print FILE $message;
		close(FILE);
		system "mv $startdir/$hostname/message.mom $startdir/$hostname/message";
		&unlock(MOMFILE);
		print "Message stored.\n";
		close(MOMFILE);
		return undef;
	}

print "$_: Command not found.\n";
return undef;
}




sub input
{
	$_=<CON>;
	s/\r//g;
	s/\n//g;
	return $_;
}

sub reloadMessagetable
{
	undef %filename;
	opendir(MOMDIR,"$startdir/$hostname/messages") || return -1;
	$number=0;
	@array=grep(/MSG_/,readdir(MOMDIR));
	closedir(MOMDIR);
	foreach $momfile ( @array ) 
	{
		open(FILE,"$startdir/$hostname/messages/$momfile") || return -1;
		$number++;
		$filename{$number}="$momfile";
		undef $author{$number};
		undef $subject{$number};
		while(<FILE>)
		{
			tr/A-Z/a-z/;
			s/  //g;
			s/\r//g;
			s/\n//g;
			$author{$number}=$1		if	!$author{$number} && /author\s*:(.*)$/;
			$subject{$number}=$1	if	!$subject{$number} && /subject\s*:(.*)$/;
		}
		close(FILE);
	}
	return 1;
}


sub reloadPasswd
{
	open(FILE,"$startdir/$hostname/passwd")  || return -1;
	&lock(FILE)	|| return -1;	
	while(<FILE>)
	{
		chop;
		if(!/^#/)
		{
			($name,$pwd,$grp,$rname,$email)=split(/:/,$_);
			$login{$name}=1;
			$passwd{$name}=$pwd;
			$group{$name}=$grp;
			$realname{$name}=$rname;
			$email{$name}=$email;
		}
	}
	&unlock(FILE);
	close(FILE);
	return 1;
}


sub lock 
{
	local($fd)=@_;
	return flock($fd,&LOCK_EX)
}

sub unlock
{
	local($fd)=@_;
	return flock($fd,&LOCK_UN);
}
